
TYPO3.Fluid - Bug # 3657

Status: Resolved Priority: Should have
Author: Marcel Rosenberger Category:
Created: 2009-06-14 Assigned To: Bastian Waidelich
Updated: 2010-10-20 Due date:
Has patch:
Affected Flow version:
Subject: <f:form.select does not allow to specify selectedValue
Description

The following code from documentation does not work:

<f:form.select name="paymentOptions" options="{payPal: 'PayPal International Services', visa: 'VISA Card'}"
selectedValue="visa" />

Error:

PHP Fatal error:  Uncaught exception 'Tx_Fluid_Core_Parser_Exception' with message 'Argument "selectedValue" 
was not registered.' in typo3\sysext\fluid\Classes\Core\Parser\TemplateParser.php:402

History
#1 - 2009-06-14 01:36 - Christian Müller
- File fluid_3657.patch added

Well, could you try this patch?

I do not think it will be final, as I am not sure about the value of $selectedValue in case of nothing selected (first render of form). Hope the check works
with === false...

#2 - 2009-06-14 01:55 - Marcel Rosenberger

After applying the patch no error is thrown anymore. However the "visa" option is not selected.

#3 - 2009-06-14 19:09 - Christian Müller

Marcel R. wrote:

After applying the patch no error is thrown anymore. However the "visa" option is not selected.

A change from

if(($selectedValue === false) && $this->arguments->hasArgument('selectedValue') && ($this->arguments['selectedValue'] === (string)$value)){
to

if(empty($selectedValue) && $this->arguments->hasArgument('selectedValue') && ($this->arguments['selectedValue'] === (string)$value)){

should make it working, but has other non wished effect (will always select options with emtpy or zero value), so the return value of $selectedValue has
to be changed I think.

#4 - 2009-06-22 11:40 - Bastian Waidelich

Marcel R. wrote:

The following code from documentation does not work:

the documentation is wrong here. All Form view helpers have an argument "value". Could you please try whether this works:
<f:form.select name="paymentOptions" options="{payPal: 'PayPal International Services', visa: 'VISA Card'}" value="visa" />

btw: have a look at https://svn.typo3.org/TYPO3v4/CoreProjects/MVC/viewhelpertest/ to see all the extisting view helpers in action

#5 - 2009-06-22 11:41 - Bastian Waidelich
- Status changed from New to Needs Feedback

#6 - 2009-06-22 15:52 - Marcel Rosenberger

With attribute value it's working. I tested:

<f:form.select name="paymentOptions" options="{payPal: 'PayPal International Services', visa: 'VISA Card', master: 'MasterCard'}"
value="visa" />

as well as

<f:form.select name="paymentOptions" options="{payPal: 'PayPal International Services', visa: 'VISA Card', master: 'MasterCard'}" value="{0:
'master', 1: 'visa'}" multiple="multiple" />

I would like to see the documentation changed inside SelectViewHelper.php accordingly.

#7 - 2009-07-22 10:36 - Bastian Waidelich
- Status changed from Needs Feedback to Accepted
- Assigned To set to Bastian Waidelich

#8 - 2009-07-31 12:06 - Bastian Waidelich
- Status changed from Accepted to Resolved

Inline documentation has been fixed in r2914
#9 - 2009-10-21 17:53 - Bastian Waidelich
- Project changed from Extbase MVC Framework to TYPO3.Fluid
- Category deleted (432)

Files
fluid_3657.patch 1.3 kB 2009-06-14 Christian Müller
